package com.jmeeting.gui;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import com.jmeeting.util.SeverUtil;
import com.jmeeting.util.ClientUtil;

/*
 * Jmeeting.java
 *
 * Created on __DATE__, __TIME__
 */

/**
 *
 * @author  __USER__
 */
public class Jmeeting extends javax.swing.JFrame {

	/** Creates new form Jmeeting */
	private SeverUtil severUtil = new SeverUtil();
	private ClientUtil clientUtil = new ClientUtil();
	private About about = new About();
	private Toolkit toolkit = getToolkit();
	private Dimension dimension = toolkit.getScreenSize();
	public static boolean joinflags = true;
	public static boolean meetingflags = true;
	private static String ip = null;
	private static int port = 0;

	public Jmeeting() {
		initComponents();
		about.setLocation((int) dimension.getWidth() / 3, (int) dimension
				.getHeight() / 3);
		about.setVisible(false);
		this.setLocation((int) dimension.getWidth() / 4, (int) dimension
				.getHeight() / 4);
	}

	public static String getIP() {
		return ip;
	}

	public static int getPort() {
		return port;
	}

	private boolean checkIP(String checkStr) //检查IP
	{
		try {
			String number = checkStr.substring(0, checkStr.indexOf('.'));
			if (Integer.parseInt(number) > 255)
				return false;
			checkStr = checkStr.substring(checkStr.indexOf('.') + 1);
			number = checkStr.substring(0, checkStr.indexOf('.'));
			if (Integer.parseInt(number) > 255)
				return false;
			checkStr = checkStr.substring(checkStr.indexOf('.') + 1);
			number = checkStr.substring(0, checkStr.indexOf('.'));
			if (Integer.parseInt(number) > 255)
				return false;
			number = checkStr.substring(checkStr.indexOf('.') + 1);
			if (Integer.parseInt(number) > 255)
				return false;
			return true;
		} catch (Exception e) {
			return false;
		}
	}

	public boolean isNumeric(String str) {//检查端口
		Pattern pattern = Pattern.compile("[0-9]*");
		Matcher isNum = pattern.matcher(str);
		if (!isNum.matches()) {
			return false;
		}
		return true;
	}

	//GEN-BEGIN:initComponents
	// <editor-fold defaultstate="collapsed" desc="Generated Code">
	private void initComponents() {

		jButton1 = new javax.swing.JButton();
		jButton2 = new javax.swing.JButton();
		jButton3 = new javax.swing.JButton();
		jLabel1 = new javax.swing.JLabel();
		jLabel2 = new javax.swing.JLabel();
		jScrollPane1 = new javax.swing.JScrollPane();
		jTextArea1 = new javax.swing.JTextArea();
		jButton4 = new javax.swing.JButton();
		jTextField1 = new javax.swing.JTextField();
		jTextField2 = new javax.swing.JTextField();
		jMenuBar1 = new javax.swing.JMenuBar();
		jMenu1 = new javax.swing.JMenu();
		jMenuItem1 = new javax.swing.JMenuItem();
		jMenuItem5 = new javax.swing.JMenuItem();
		jMenuItem2 = new javax.swing.JMenuItem();
		jMenuItem3 = new javax.swing.JMenuItem();
		jMenu2 = new javax.swing.JMenu();
		jMenu3 = new javax.swing.JMenu();
		jMenuItem4 = new javax.swing.JMenuItem();

		setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
		setTitle("Jmeeting\u89c6\u9891\u4f1a\u8bae");
		setResizable(false);

		jButton1.setFont(new java.awt.Font("Sans", 1, 12));
		jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/gtk/resources/gtk-yes-4.png"))); // NOI18N
		jButton1.setText("\u4e3b\u6301");
		jButton1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton1ActionPerformed(evt);
			}
		});

		jButton2.setFont(new java.awt.Font("Sans", 1, 12));
		jButton2.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/gtk/resources/gtk-ok-4.png"))); // NOI18N
		jButton2.setText("\u53c2\u4e0e");
		jButton2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton2ActionPerformed(evt);
			}
		});

		jButton3.setFont(new java.awt.Font("Sans", 1, 12));
		jButton3.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/gtk/resources/gtk-cancel-4.png"))); // NOI18N
		jButton3.setText("\u4e2d\u65ad");
		jButton3.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton3ActionPerformed(evt);
			}
		});

		jLabel1.setFont(new java.awt.Font("Sans", 1, 15));
		jLabel1.setText("IP\u5730\u5740\uff1a");

		jLabel2.setFont(new java.awt.Font("Sans", 1, 15));
		jLabel2.setText("\u7aef\u53e3\uff1a");

		jTextArea1.setColumns(20);
		jTextArea1.setRows(5);
		jScrollPane1.setViewportView(jTextArea1);

		jButton4.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/gtk/resources/gtk-no-4.png"))); // NOI18N
		jButton4.setText("\u79bb\u5f00");
		jButton4.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton4ActionPerformed(evt);
			}
		});

		jTextField1.setText("127.0.0.1");

		jTextField2.setText("30009");

		jMenu1.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/windows/icons/Computer.gif"))); // NOI18N
		jMenu1.setText("\u547c\u53eb");

		jMenuItem1.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/gtk/resources/gtk-yes-4.png"))); // NOI18N
		jMenuItem1.setText("\u4e3b\u6301\u4f1a\u8bae");
		jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItem1ActionPerformed(evt);
			}
		});
		jMenu1.add(jMenuItem1);

		jMenuItem5.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/gtk/resources/gtk-cancel-4.png"))); // NOI18N
		jMenuItem5.setText("\u4e2d\u65ad\u4f1a\u8bae");
		jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItem5ActionPerformed(evt);
			}
		});
		jMenu1.add(jMenuItem5);

		jMenuItem2.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/gtk/resources/gtk-ok-4.png"))); // NOI18N
		jMenuItem2.setText("\u53c2\u4e0e\u4f1a\u8bae");
		jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItem2ActionPerformed(evt);
			}
		});
		jMenu1.add(jMenuItem2);

		jMenuItem3.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/gtk/resources/gtk-no-4.png"))); // NOI18N
		jMenuItem3.setText("\u79bb\u5f00\u4f1a\u8bae");
		jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItem3ActionPerformed(evt);
			}
		});
		jMenu1.add(jMenuItem3);

		jMenuBar1.add(jMenu1);

		jMenu2.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/windows/icons/HardDrive.gif"))); // NOI18N
		jMenu2.setText("\u5de5\u5177");
		jMenuBar1.add(jMenu2);

		jMenu3.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/windows/icons/File.gif"))); // NOI18N
		jMenu3.setText("\u5e2e\u52a9");

		jMenuItem4.setIcon(new javax.swing.ImageIcon(getClass().getResource(
				"/com/sun/java/swing/plaf/motif/icons/Question.gif"))); // NOI18N
		jMenuItem4.setText("\u5173\u4e8e");
		jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jMenuItem4ActionPerformed(evt);
			}
		});
		jMenu3.add(jMenuItem4);

		jMenuBar1.add(jMenu3);

		setJMenuBar(jMenuBar1);

		org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(
				getContentPane());
		getContentPane().setLayout(layout);
		layout
				.setHorizontalGroup(layout
						.createParallelGroup(
								org.jdesktop.layout.GroupLayout.LEADING)
						.add(
								layout
										.createSequentialGroup()
										.addContainerGap()
										.add(
												layout
														.createParallelGroup(
																org.jdesktop.layout.GroupLayout.TRAILING)
														.add(
																org.jdesktop.layout.GroupLayout.LEADING,
																jScrollPane1,
																org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																362,
																Short.MAX_VALUE)
														.add(
																org.jdesktop.layout.GroupLayout.LEADING,
																layout
																		.createSequentialGroup()
																		.add(
																				jLabel1,
																				org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
																				62,
																				org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
																		.addPreferredGap(
																				org.jdesktop.layout.LayoutStyle.RELATED)
																		.add(
																				jTextField1,
																				org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																				124,
																				Short.MAX_VALUE)
																		.addPreferredGap(
																				org.jdesktop.layout.LayoutStyle.RELATED)
																		.add(
																				jLabel2,
																				org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
																				48,
																				org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
																		.addPreferredGap(
																				org.jdesktop.layout.LayoutStyle.RELATED)
																		.add(
																				jTextField2,
																				org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
																				92,
																				org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
														.add(
																org.jdesktop.layout.GroupLayout.LEADING,
																layout
																		.createSequentialGroup()
																		.add(
																				jButton1,
																				org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																				88,
																				Short.MAX_VALUE)
																		.addPreferredGap(
																				org.jdesktop.layout.LayoutStyle.RELATED)
																		.add(
																				jButton3,
																				org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																				84,
																				Short.MAX_VALUE)
																		.addPreferredGap(
																				org.jdesktop.layout.LayoutStyle.RELATED)
																		.add(
																				jButton2,
																				org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																				84,
																				Short.MAX_VALUE)
																		.addPreferredGap(
																				org.jdesktop.layout.LayoutStyle.RELATED)
																		.add(
																				jButton4,
																				org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																				org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																				Short.MAX_VALUE)))
										.addContainerGap()));
		layout
				.setVerticalGroup(layout
						.createParallelGroup(
								org.jdesktop.layout.GroupLayout.LEADING)
						.add(
								org.jdesktop.layout.GroupLayout.TRAILING,
								layout
										.createSequentialGroup()
										.addContainerGap()
										.add(
												layout
														.createParallelGroup(
																org.jdesktop.layout.GroupLayout.BASELINE)
														.add(jLabel1)
														.add(jLabel2)
														.add(
																jTextField1,
																org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
																org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
														.add(
																jTextField2,
																org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
																org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
										.addPreferredGap(
												org.jdesktop.layout.LayoutStyle.RELATED)
										.add(
												jScrollPane1,
												org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
												318, Short.MAX_VALUE)
										.addPreferredGap(
												org.jdesktop.layout.LayoutStyle.RELATED)
										.add(
												layout
														.createParallelGroup(
																org.jdesktop.layout.GroupLayout.BASELINE)
														.add(jButton1).add(
																jButton4).add(
																jButton3).add(
																jButton2))
										.addContainerGap()));

		pack();
	}// </editor-fold>
	//GEN-END:initComponents

	private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		// TODO add your handling code here:
		if (joinflags == false) {
			clientUtil.clientStop();
			joinflags = true;
		} else {
			JOptionPane.showMessageDialog(this, "你还没有参加一个会议", "消息",
					JOptionPane.WARNING_MESSAGE);

		}
	}

	private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		// TODO add your handling code here:
		if (joinflags == true) {
			if (checkIP(jTextField1.getText())
					&& isNumeric(jTextField2.getText())) {
				ip = jTextField1.getText();
				port = Integer.parseInt(jTextField2.getText());
				clientUtil.clientStart();
				joinflags = false;
				this.setExtendedState(JFrame.ICONIFIED);
			} else {
				JOptionPane.showMessageDialog(this, "请检查IP和端口！", "消息",
						JOptionPane.WARNING_MESSAGE);

			}

		} else {
			JOptionPane.showMessageDialog(this, "你已经开始了一个会议", "消息",
					JOptionPane.WARNING_MESSAGE);

		}
	}

	private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		// TODO add your handling code here:
		if (meetingflags == false) {
			severUtil.severStop();
			meetingflags = true;
			jTextField1.setEditable(false);
		} else {
			JOptionPane.showMessageDialog(this, "你还没有主持一个会议了！", "消息",
					JOptionPane.WARNING_MESSAGE);
		}
	}

	private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		// TODO add your handling code here:
		if (meetingflags == true) {
			if (isNumeric(jTextField2.getText())) {
				port = Integer.parseInt(jTextField2.getText());
				severUtil.severStart();
				meetingflags = false;
				this.setExtendedState(JFrame.ICONIFIED);

				jTextField1.setEditable(false);
			} else {
				JOptionPane.showMessageDialog(this, "请输入一个正确的端口！", "消息",
						JOptionPane.WARNING_MESSAGE);
			}

		} else {
			JOptionPane.showMessageDialog(this, "你已经正在主持一个会议了！", "消息",
					JOptionPane.WARNING_MESSAGE);
		}
	}

	private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		about.setVisible(true);
	}

	private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		if (joinflags == false) {
			clientUtil.clientStop();
			joinflags = true;
		} else {
			JOptionPane.showMessageDialog(this, "你还没有参加一个会议", "消息",
					JOptionPane.WARNING_MESSAGE);

		}

	}

	private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		if (joinflags == true) {
			if (checkIP(jTextField1.getText())
					&& isNumeric(jTextField2.getText())) {
				ip = jTextField1.getText();
				port = Integer.parseInt(jTextField2.getText());
				clientUtil.clientStart();
				joinflags = false;
				this.setExtendedState(JFrame.ICONIFIED);
			} else {
				JOptionPane.showMessageDialog(this, "请检查IP和端口！", "消息",
						JOptionPane.WARNING_MESSAGE);

			}

		} else {
			JOptionPane.showMessageDialog(this, "你已经开始了一个会议", "消息",
					JOptionPane.WARNING_MESSAGE);

		}

	}

	private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		if (meetingflags == false) {
			severUtil.severStop();
			meetingflags = true;
			jTextField1.setEditable(false);
		} else {
			JOptionPane.showMessageDialog(this, "你还没有主持一个会议了！", "消息",
					JOptionPane.WARNING_MESSAGE);
		}

	}

	private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		if (meetingflags == true) {
			if (isNumeric(jTextField2.getText())) {
				port = Integer.parseInt(jTextField2.getText());
				severUtil.severStart();
				meetingflags = false;
				this.setExtendedState(JFrame.ICONIFIED);

				jTextField1.setEditable(false);
			} else {
				JOptionPane.showMessageDialog(this, "请输入一个正确的端口！", "消息",
						JOptionPane.WARNING_MESSAGE);
			}

		} else {
			JOptionPane.showMessageDialog(this, "你已经正在主持一个会议了！", "消息",
					JOptionPane.WARNING_MESSAGE);
		}

	}

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new Jmeeting().setVisible(true);
			}
		});
	}

	//GEN-BEGIN:variables
	// Variables declaration - do not modify
	private javax.swing.JButton jButton1;
	private javax.swing.JButton jButton2;
	private javax.swing.JButton jButton3;
	private javax.swing.JButton jButton4;
	private javax.swing.JLabel jLabel1;
	private javax.swing.JLabel jLabel2;
	private javax.swing.JMenu jMenu1;
	private javax.swing.JMenu jMenu2;
	private javax.swing.JMenu jMenu3;
	private javax.swing.JMenuBar jMenuBar1;
	private javax.swing.JMenuItem jMenuItem1;
	private javax.swing.JMenuItem jMenuItem2;
	private javax.swing.JMenuItem jMenuItem3;
	private javax.swing.JMenuItem jMenuItem4;
	private javax.swing.JMenuItem jMenuItem5;
	private javax.swing.JScrollPane jScrollPane1;
	private javax.swing.JTextArea jTextArea1;
	private javax.swing.JTextField jTextField1;
	private javax.swing.JTextField jTextField2;
	// End of variables declaration//GEN-END:variables

}