package com.jmeeting.util;

import com.jmeeting.client.*;
import com.jmeeting.gui.*;
public class ClientUtil {

	private ServerGUI clientGui;

	private WriteGUI writeGUI;

	private Thread clientThread;

	public void clientStart() {

		clientGui = new ServerGUI(Jmeeting.getIP());

		writeGUI = new WriteGUI(clientGui);

		writeGUI.changePort(Jmeeting.getPort());

		clientThread = new Thread(writeGUI);

		clientThread.start();

	}

	public void clientStop() {

		clientThread.stop();

		clientGui.dispose();

	}
}
