package com.jmeeting.client;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;

public class ServerGUI extends JFrame {
private static final long serialVersionUID = 2273190419221320707L;
JLabel jlabel;
JScrollPane scroll;
private String ip;
private int port;
private boolean boo;
public boolean getBoo(){
   return this.boo;
}
public int getPort(){
   return this.port;
}
public void changePort(int port){
   this.port=port;
}
public String getIP(){
   return this.ip;
}
public boolean changeIP(String ip){
   if(UtilServer.checkIp(ip)){
    this.setTitle(this.getTitle().replace(this.ip, ip));
    this.ip=ip;
    return true;
   }
   return false;
}

public ServerGUI(String IP) {
   this.boo = true;
   this.ip = IP;
  
   this.setTitle("参与会议--IP:" + IP + "--主题:");
   this.jlabel = new JLabel();
   this.scroll = new JScrollPane();
   this.scroll.add(this.jlabel);

   
   this.add(scroll);
   
   this.setAlwaysOnTop(false);
   Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
   this.setBounds(100, 75, (int) screenSize.getWidth() - 200, (int) screenSize.getHeight() - 150);
   // this.setResizable(false);
   this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);// 关闭窗体不做任何事
   this.addWindowListener(new WindowAdapter() {
    public void windowClosing(WindowEvent e) {
     boo = false;
     com.jmeeting.gui.Jmeeting.joinflags=true;
     ServerGUI.this.dispose();
     System.out.println("窗体关闭");
     System.gc();
    }
   });
   this.setVisible(true);
   this.validate();
   
}
}
